#
# Menu Fantastic Plugin by gutemine
#

from enigma import *
from Screens.Screen import Screen
from Screens.Standby import *
from Screens.MessageBox import MessageBox
from Screens.InputBox import InputBox
from Screens.ChoiceBox import ChoiceBox
from Components.ActionMap import ActionMap, NumberActionMap
from Components.ScrollLabel import ScrollLabel
from Components.GUIComponent import *
from Components.MenuList import MenuList
from Components.Input import Input
from Screens.Console import Console
from Plugins.Plugin import PluginDescriptor
from RecordTimer import *
from time import *
import os
from Tools import Directories, Notifications
import NavigationInstance

# plugin calling support comes here ...

pluginpath = "/usr/lib/enigma2/python/Plugins/"

from Screens.Ci import *

# Multiboot
if os.path.exists("%s/Extensions/Multiboot" %pluginpath) is True:
   from Plugins.Extensions.Multiboot.plugin import *
# BP
if os.path.exists("/usr/lib/enigma2/python/Bp") is True:
   from Bp.BPmenu import BPmenu
# Barry Allen 
if os.path.exists("%s/Extensions/BarryAllen/" %pluginpath) is True:
   from Plugins.Extensions.BarryAllen.plugin import *
# Spider Fan
if os.path.exists("%s/Extensions/SpiderFan" %pluginpath) is True:
   from Plugins.Extensions.SpiderFan.plugin import *
# Elektro
if os.path.exists("%s/Extensions/Elektro" %pluginpath) is True:
   from Plugins.Extensions.Elektro.plugin import *
# Diabolius
if os.path.exists("%s/Extensions/Diabolius" %pluginpath) is True:
   from Plugins.Extensions.Diabolius.plugin import *
# Sakrileg
if os.path.exists("%s/Extensions/Sakrileg" %pluginpath) is True:
   from Plugins.Extensions.Sakrileg.plugin import *
# Captain Shell
if os.path.exists("%s/Extensions/Shell" %pluginpath) is True:
   from Plugins.Extensions.Shell.plugin import *
# Telefonbuch
if os.path.exists("%s/Extensions/Telefonbuch" %pluginpath) is True:
   from Plugins.Extensions.Telefonbuch.plugin import *
# PicturePlayer
if os.path.exists("%s/Extensions/PicturePlayer" %pluginpath) is True:
   from Plugins.Extensions.PicturePlayer.plugin import *
# Tuxtxt
if os.path.exists("%s/Extensions/Tuxtxt" %pluginpath) is True:
   from Plugins.Extensions.Tuxtxt.plugin import *
# ConfigurationBackup
if os.path.exists("%s/SystemPlugins/ConfigurationBackup" %pluginpath) is True:
   try:
      from Plugins.SystemPlugins.ConfigurationBackup.plugin import *
   except:
      pass
# SkinSelector
if os.path.exists("%s/SystemPlugins/SkinSelector" %pluginpath) is True:
   try:
      from Plugins.SystemPlugins.SkinSelector.plugin import *
   except:
      pass
# G* Suite 
if os.path.exists("%s/Extensions/GboxSuite" %pluginpath) is True:
   try:
      from Plugins.Extensions.GboxSuite.plugin import *
   except:
      pass
# CCcamInfo
if os.path.exists("%s/Extensions/CCcamInfo" %pluginpath) is True:
   try:
      from Plugins.Extensions.CCcamInfo.plugin import *
   except:
      pass
# KeyUpdater
if os.path.exists("%s/Extensions/KeyUpdater" %pluginpath) is True:
   try:
      from Plugins.Extensions.KeyUpdater.plugin import *
   except:
      pass
# LasMail
if os.path.exists("%s/Extensions/LasMail" %pluginpath) is True:
   from Plugins.Extensions.LasMail.plugin import *   
# TuxCom
if os.path.exists("%s/Extensions/Tuxcom" %pluginpath) is True:
   from Plugins.Extensions.Tuxcom.plugin import *
# Cronmanager
if os.path.exists("%s/Extensions/Cronmanager" %pluginpath) is True:
  from Plugins.Extensions.Cronmanager.plugin import *
# TuxGames
if os.path.exists("%s/Extensions/TuxboxGames" %pluginpath) is True:
  from Plugins.Extensions.TuxboxGames.plugin import *
# FrontprocessorUpgrade
if os.path.exists("%s/SystemPlugins/FrontprocessorUpgrade" %pluginpath) is True:
  try:
     from Plugins.SystemPlugins.FrontprocessorUpgrade.plugin import *
  except:
     pass
# SoftwareUpdate
if os.path.exists("%s/SystemPlugins/SoftwareUpdate" %pluginpath) is True:
  from Plugins.SystemPlugins.SoftwareUpdate.plugin import *
# weinbergtagger
if os.path.exists("%s/Extensions/weinbergtagger" %pluginpath) is True:
  from Plugins.Extensions.weinbergtagger.plugin import *
 
   
fantastic_pluginversion = "Field Test Version 0.1.1"
fantastic_pluginpath = "/usr/lib/enigma2/python/Plugins/Extensions/Fantastic"
fantastic_readme = "/usr/lib/enigma2/python/Plugins/Extensions/Fantastic/readme.txt"
splitchar = ":"

def autostart(reason, **kwargs):
	pass
        
	if "session" in kwargs:
	   FantasticBoot(kwargs["session"])
	
def Plugins(**kwargs):
    try:
	return [PluginDescriptor(where = [PluginDescriptor.WHERE_SESSIONSTART, PluginDescriptor.WHERE_AUTOSTART], fnc = autostart),
			PluginDescriptor(name="Menu Fantastic", description="Menu Fantastic Plugin", where = PluginDescriptor.WHERE_PLUGINMENU, icon="fantastic.png", fnc=main),
			PluginDescriptor(name="Menu Fantastic", description="Menu Fantastic Plugin", where = PluginDescriptor.WHERE_EXTENSIONSMENU, icon="fantastic.png", fnc=main)]
    except:
	return [PluginDescriptor(where = [PluginDescriptor.WHERE_SESSIONSTART, PluginDescriptor.WHERE_AUTOSTART], fnc = autostart),PluginDescriptor(name="Fantastic", description="Menu Fantastic Plugin", where = PluginDescriptor.WHERE_PLUGINMENU, icon="fantastic.png", fnc=main)]

def main(session,**kwargs):
    try:    
     	session.open(Fantastic)
    except:
        print "[FANTASTIC] Pluginexecution failed"

class Fantastic(Screen):
    skin = """
        <screen position="100,100" size="500,400" title="Menu Fantastic Plugin" >
            <widget name="menu" position="10,10" size="490,390" scrollbarMode="showOnDemand" />
        </screen>"""
        
    def __init__(self, session, args = 0):
        self.skin = Fantastic.skin
        self.session = session
        Screen.__init__(self, session)
        self.menu = args
        
        global mfcommand
        global mfmenu
        global mfmenuold
        global mfexecute
        global mfmenudescr
        global mfintargument
        global mftextargument

        try:    
           if mfmenu is None:
              pass
        except:
           mfmenu="main"
           mfmenuold="main"
           mfmenudescr="Menu Fantastic Main Menu"

        if mfmenu is "red":
           pass
        elif mfmenu is "green":
           pass
        elif mfmenu is "yellow":
           pass
        elif mfmenu is "blue":
           pass
        else:
           mfmenu="main"
           mfmenuold="main"
           mfmenudescr="Menu Fantastic Main Menu"

        mfexecute=" "
        mfintargument=0
        mftextargument=" "
                
        mainmenu = []

        menufile = "%s/%s.cfg" % (fantastic_pluginpath,mfmenu)
        if os.path.exists(menufile) is True:
           mf = open(menufile,"r")
           for line in mf:
              parts=line.split(splitchar,3)
              index=len(parts)
   
              if index > 1:
                 command=parts[0].upper().rstrip()
                 mfcommand=command[0]
                 if mfcommand is not "S":
                    if index >2:
                       mainmenu.append(( str(parts[2]), line ))
                    else:
                       mainmenu.append(( str(parts[1]), line ))
 
           mf.close()
        else:
           mainmenu.append(("no %s.cfg found - select for details" %mfmenu, "mfnomenu"))        

        mainmenu.append(("Show readme.txt", "mfreadme"))        
        mainmenu.append(("about %s" %fantastic_pluginversion , "mfabout"))        

        self["menu"] = MenuList(mainmenu)
        self["actions"] = ActionMap(["WizardActions", "DirectionActions"],{"ok": self.FantasticMainMenu,"back": self.close,}, -1)
        
    def FantasticMainMenu(self):

        global mfcommand
        global mfmenu
        global mfmenuold
        global mfexecute
        global mfmenudescr
        global mfintargument
        global mftextargument

        mfselected = self["menu"].l.getCurrentSelection()[1]

        if mfselected is not None:
           if mfselected is "mfreadme":
                self.session.open(Console,_("Showing Fantastic readme.txt"),["cat %s" % fantastic_readme])
           elif mfselected is "mfnomenu":
               title1=_("Menu Fantastic Plugin") 
               title2=_("needs a %s.cfg file at" % mfmenu)
               title3=_("%s" %fantastic_pluginpath)
               title="%s\n%s\n%s" % (title1, title2,title3)
               self.session.open(MessageBox,("%s") % (title),  MessageBox.TYPE_INFO)
           elif mfselected is "mfabout":
               title1=_("Menu Fantastic Plugin %s") % fantastic_pluginversion
               title2=_("by gutemine is Freeware - use at your own risk !")
               title="%s\n%s" % (title1, title2)
               self.session.open(MessageBox,("%s") % (title),  MessageBox.TYPE_INFO)
           else:
               self.FantasticMenuSelected(mfselected)

    def FantasticMenu(self,status):

        global mfcommand
        global mfmenu
        global mfmenuold
        global mfexecute
        global mfmenudescr
        global mfintargument
        global mftextargument

        if mfmenu is None:
           self.skipMF("No menu passed, returning")
        else:
           mfmenufile = "%s/%s.cfg" % (fantastic_pluginpath,mfmenu.rstrip())
           if os.path.exists(mfmenufile) is True:
              mf = open(mfmenufile,"r")
              line=mf.readline()
              mf.close()
              parts=line.split(splitchar,3)
              index=len(parts)
              if index > 1:
                 command=parts[0].upper().rstrip()
                 # only if menu file contains S in first line startup is executed
                 if command[0] is "S":
                    if index > 3:
                       cmd=parts[3].rstrip()
                       if mfmenu == mfmenuold:
                          pass
                       elif mfmenu == "main":
                          pass
                       else:
                          if os.path.exists("%s/%s" %(fantastic_pluginpath,cmd)) is True:
                             os.system("%s/%s %s" % (fantastic_pluginpath,cmd,mftextargument))
                          else:
                             os.system("%s %s" % (cmd,mftextargument))
                       
                       mfmenudescr=parts[2].rstrip()
                    else:
                       if index is 3:
                          mfmenudescr=parts[2].rstrip()
                       else:
                          mfmenudescr=parts[1].rstrip()
                          
           if os.path.exists("%s/%s.cfg" % (fantastic_pluginpath,mfmenu.rstrip())) is True:
              if mfmenu == "main":
                 pass
              else:
                 self.session.openWithCallback(self.FantasticMenuSelected,ChoiceBox,mfmenudescr,self.ListMenuFantastic())        
           else:
              self.skipMF("no Menufile %s.cfg" %mfmenu)

    def FantasticMenuSelected(self,mfselected):

        global mfcommand
        global mfmenu
        global mfmenuold
        global mfexecute
        global mfmenudescr
        global mfintargument
        global mftextargument


        if mfselected is None:
#           self.skipMF("nothing selected")
           mfmenu="main"
        else:
           try:
              parts=mfselected.split(splitchar,4)
           except:
              parts=mfselected[1].split(splitchar,4)

           mfcommand=" "
           mfexecute=" "
           mfintargument=0
           mftextargument=" "

           index=len(parts)
           if index > 1:
              command=parts[0].upper().rstrip()
              mfcommand=command[0]
           else:
              command=" "
              mfcommand=command[0]

           if index > 1:
              mfmenuold=mfmenu
              mfmenu=parts[1].rstrip()

           if index > 2:
              mfmenudescr=parts[2].rstrip()
           else:
              mfmenudescr=parts[1].rstrip()
              
           if index > 3:
              mfexecute=parts[3].rstrip()
              mftextargument=parts[3].rstrip()

           if index > 4:
              mftextargument=parts[4].rstrip()
              try:
                 mfintargument=int(mftextargument)
              except:
                 mfintargument = 0
           elif index == 4:
              mftextargument=parts[3].rstrip()
              try:
                 mfintargument=int(mftextargument)
              except:
                 mfintargument = 0
           else:
              pass

           if mfcommand is "E":
              if os.path.exists("%s/%s" % (fantastic_pluginpath,mfexecute)) is True:
                 os.system("%s/%s %s" % (fantastic_pluginpath,mfexecute,mftextargument))
              else:
                 os.system("%s %s"  % (mfexecute,mftextargument))
              self.session.openWithCallback(self.FantasticMenu,MessageBox,"%s %s was executed !" %(mfexecute,mftextargument), MessageBox.TYPE_INFO, timeout=mfintargument)
           elif mfcommand is "C":
              if os.path.exists("%s/%s" % (fantastic_pluginpath,mfexecute)) is True:
                 self.session.openWithCallback(self.FantasticMenu(""),Console,_("Executing %s %s" %(mfexecute, mftextargument)),["%s/%s %s" % (fantastic_pluginpath,mfexecute,mftextargument) ])
              else:
                 self.session.openWithCallback(self.FantasticMenu(""),Console,_("Executing %s %s" %(mfexecute, mftextargument)),["%s %s" % (mfexecute, mftextargument) ])
           elif mfcommand is "A":
              FantasticApplication(self.session)
              self.FantasticMenu("")
           elif mfcommand is "P":
              plugininstalled=False
              if os.path.exists("%s/Extensions/%s" %(pluginpath,mftextargument)) is True:
                 plugininstalled=True
              if os.path.exists("%s/SystemPlugins/%s" %(pluginpath,mftextargument)) is True:
                 plugininstalled=True
                 
              if plugininstalled is True:
                 if mftextargument == "Tuxtxt":
                    self.session.openWithCallback(self.FantasticMenu(""),ShellStarter)
                 elif mftextargument == "BarryAllen":
                    self.session.openWithCallback(self.FantasticMenu(""),BarryAllenPlugin)
                 elif mftextargument == "Multiboot":
                    self.session.openWithCallback(self.FantasticMenu(""),Multiboot)
                 elif mftextargument == "SpiderFan":
                    self.session.openWithCallback(self.FantasticMenu(""),SpiderFan)
                 elif mftextargument == "Elektro":
                    self.session.openWithCallback(self.FantasticMenu(""),Elektro)
                 elif mftextargument == "Diabolius":
                    self.session.openWithCallback(self.FantasticMenu(""),Diabolius)
                 elif mftextargument == "Sakrileg":
                    self.session.openWithCallback(self.FantasticMenu(""),Sakrileg)
                 elif mftextargument == "Shell":
                    self.session.openWithCallback(self.FantasticMenu(""),Shell)
                 elif mftextargument == "Telefonbuch":
                    self.session.openWithCallback(self.FantasticMenu(""),Telefonbuch)
                 elif mftextargument == "PicturePlayer":
                    self.session.openWithCallback(self.FantasticMenu(""),picmain)
                 elif mftextargument == "ConfigurationBackup":
                    try:
                       self.session.openWithCallback(self.FantasticMenu(""),BackupSetup)
                    except:
                       pass  
		 elif mftextargument == "GboxSuite":
                    try:
                       self.session.openWithCallback(self.FantasticMenu(""),GboxSuite)
                    except:
                       pass  
		 elif mftextargument == "KeyUpdater":
                    try:
                       self.session.openWithCallback(self.FantasticMenu(""),KeyUpdater)
                    except:
                       pass  
		 elif mftextargument == "CCcamInfo":
                    try:
                       self.session.openWithCallback(self.FantasticMenu(""),CCcamInfo)
                    except:
                       pass  
		 elif mftextargument == "LasMail":
                    self.session.openWithCallback(self.FantasticMenu(""),LasMail)	
                 elif mftextargument == "Tuxcom":
                    self.session.openWithCallback(self.FantasticMenu(""),TuxComStarter)
                 elif mftextargument == "Cronmanager":
                    self.session.openWithCallback(self.FantasticMenu(""),Cronmanager)
                 elif mftextargument == "TuxboxGames":
                    self.session.openWithCallback(self.FantasticMenu(""),GameStarter)
                 elif mftextargument == "FrontprocessorUpgrade":
                    self.session.openWithCallback(self.FantasticMenu(""),FPUpgrade)
                 elif mftextargument == "SoftwareUpdate":
                   self.session.openWithCallback(self.FantasticMenu(""),UpdatePluginMenu)
                 elif mftextargument == "weinbergtagger":
                   self.session.openWithCallback(self.FantasticMenu(""),weinbergtagger)
                 elif mftextargument == "SkinSelector":
                    try:
                       self.session.openWithCallback(self.FantasticMenu(""),SkinSelector)
                    except:
                       self.session.openWithCallback(self.FantasticMenu,MessageBox,"Plugin %s is not wrapped !" %mftextargument, MessageBox.TYPE_INFO)
                 else:
                    self.session.openWithCallback(self.FantasticMenu,MessageBox,"Plugin %s is not wrapped !" %mftextargument, MessageBox.TYPE_INFO)
              else:
                 if mftextargument == "Ci":
                    self.session.openWithCallback(self.FantasticMenu(""),CiSelection)
                 elif mftextargument == "BP":
                    if os.path.exists("/usr/lib/enigma2/python/Bp") is True:
                       self.session.openWithCallback(self.FantasticMenu(""),BPmenu)
                    else:
                       self.session.openWithCallback(self.FantasticMenu,MessageBox,"Plugin %s is not available !" %mftextargument, MessageBox.TYPE_INFO)
                 else:
                    self.session.openWithCallback(self.FantasticMenu,MessageBox,"Plugin %s is not installed !" %mftextargument, MessageBox.TYPE_INFO)
                    
           elif mfcommand is "R":
              if mfintargument == 3:
                 self.session.openWithCallback(self.FantasticMenu,MessageBox,"Restarting Enigma2", MessageBox.TYPE_INFO, timeout=5)
                 TryQuitMainloop(self.session,mfintargument)
              elif mfintargument == 2:
                 self.session.openWithCallback(self.FantasticMenu,MessageBox,"Restarting Dreambox", MessageBox.TYPE_INFO, timeout=5)
                 TryQuitMainloop(self.session,mfintargument)
              elif mfintargument == 1:
                 self.session.openWithCallback(self.FantasticMenu,MessageBox,"Entering Deepstandby", MessageBox.TYPE_INFO, timeout=5)
                 TryQuitMainloop(self.session,mfintargument)
              else:
                 pass
           elif mfcommand is "I":
              if os.path.exists("%s/%s.txt" %(fantastic_pluginpath,mfexecute)) is True:
                 menufile="%s/%s.txt" %(fantastic_pluginpath,mfexecute)
                 mf = open(menufile,"r")
                 mfexecute=mf.readline()
                 mf.close()
                 self.session.openWithCallback(self.FantasticMenu,MessageBox,mfexecute, MessageBox.TYPE_INFO, timeout=mfintargument)
              elif os.path.exists("/tmp/%s.txt" %(mfexecute)) is True:
                 menufile="/tmp/%s.txt" %(mfexecute)
                 mf = open(menufile,"r")
                 mfexecute=mf.readline()
                 mf.close()
                 self.session.openWithCallback(self.FantasticMenu,MessageBox,mfexecute, MessageBox.TYPE_INFO, timeout=mfintargument)
              else:
                 self.session.openWithCallback(self.FantasticMenu,MessageBox,mfexecute, MessageBox.TYPE_INFO, timeout=mfintargument)

           elif mfcommand is "D":
#              self.session.open(FantasticLCD,mftextargument)
              self.session.openWithCallback(self.FantasticMenu(""),FantasticLCD,mftextargument)

           elif mfcommand is "L":
              if mftextargument == "log":
                 os.system("echo %s > /tmp/fantasticlog.txt" %mfexecute) 
              elif mftextargument == "logappend":
                 os.system("echo %s >> /tmp/fantasticlog.txt" %mfexecute) 
              elif mftextargument == "reset":
                 if os.path.exists("/tmp/fantasticlog.txt") is True:
                    os.system("rm /tmp/fantasticlog.txt") 
              elif mftextargument == "wall":
                 os.system("wall %s" %mfexecute) 
              else:
                 print "[FANTASTIC] Logging: %s" %mfexecute
              self.FantasticMenu("")
           elif mfcommand is "M":
              self.FantasticMenu("")
           elif mfcommand is "T":
              self.session.openWithCallback(self.FantasticEnterText,InputBox, title=mfmenudescr, text=mftextargument, maxSize=False, type=Input.TEXT)
           elif mfcommand is "Y":
              self.session.openWithCallback(self.FantasticYN,MessageBox,mfmenudescr, MessageBox.TYPE_YESNO)
           else:
              pass

    def ListMenuFantastic(self):

        global mfcommand
        global mfmenu
        global mfmenuold
        global mfexecute
        global mfmenudescr
        global mfintargument
        global mftextargument

        menu = []

        menufile = "%s/%s.cfg" % (fantastic_pluginpath,mfmenu)
        mf = open(menufile,"r")

        for line in mf:
           parts=line.split(splitchar,3)
           index=len(parts)
           if index > 1:
              command=parts[0].upper().rstrip()
              if command[0] is not "S":
                 if index > 2:
                    menu.append(( str(parts[2]), line ))
                 else:
                    menu.append(( str(parts[1]), line ))
        mf.close()

        return menu

    def FantasticEnterText(self, mftext):

        global mfcommand
        global mfmenu
        global mfmenuold
        global mfexecute
        global mfmenudescr
        global mfintargument
        global mftextargument

        if mftext is None:
           mftextargument = None
           mfmenu="main"
           self.skipMF("No text passed, Exiting menu %s" % mfmenu)
        else:
           mftextargument = mftext
           self.FantasticMenu("")


    def FantasticYN(self,mfanswer):

        global mfcommand
        global mfmenu
        global mfmenuold
        global mfexecute
        global mfmenudescr
        global mfintargument
        global mftextargument

        if mfanswer is False:
           if mftextargument is not None:
              if mftextargument is not " ":
                 mfmenu=mftextargument
           
        self.FantasticMenu("")
           
    def skipMF(self,reason):
        self.session.open(MessageBox,_("Menu Fantastic exits, because %s") % reason, MessageBox.TYPE_WARNING)

class FantasticButton(Screen):
    def __init__(self,session,button):
	Screen.__init__(self,session)
	self.session = session

        global mfcommand
        global mfmenu
        global mfmenuold
        global mfexecute
        global mfmenudescr
        global mfintargument
        global mftextargument

        if button is not None:
           mfmenuold=button
           mfmenu=button
           mfmenudescr="Menu Fantastic %s Button Menu" %button
        else:
           mfmenuold="main"
           mfmenu="main"
           mfmenudescr="Menu Fantastic Main Menu"


class FantasticBoot(Screen):
	def __init__(self,session):
		Screen.__init__(self,session)
		self.session = session
		
                mainmenufile = "%s/%s.cfg" % (fantastic_pluginpath,"main")
                if os.path.exists(mainmenufile) is True:
                   mfmain = open(mainmenufile,"r")
                   line=mfmain.readline()
                   parts=line.split(splitchar,3)
                   index=len(parts)
                   if index > 1:
                      command=parts[0].upper().rstrip()
                      # only if menu file contains S in first line startup is executed
                      if command[0] is "S":
                         if index > 3:
                            cmd=parts[3].rstrip()
                            if os.path.exists("%s/%s" %(fantastic_pluginpath,cmd)) is True:
                               os.system("%s/%s" % (fantastic_pluginpath,cmd))
                            else:
                               os.system("%s" % (cmd))
                            
                         mfmain.close()
   

class FantasticApplication(Screen):

        def __init__(self, session):
                self.session = session
        	self.skin = Fantastic.skin
		Screen.__init__(self, session)
		self.container=eConsoleAppContainer()
		self.container.appClosed.get().append(self.finished)
		self.runapp()
		
	def runapp(self):
	
                global mfcommand
                global mfmenu
                global mfmenuold
                global mfexecute
                global mfmenudescr
                global mfintargument
                global mftextargument

		eDBoxLCD.getInstance().lock()
		eRCInput.getInstance().lock()
		fbClass.getInstance().lock()
                self.session.nav.stopService()
                if os.path.exists(mfexecute) is True:
 		   self.container.execute("%s %s" %(mfexecute,mftextargument))
 		else:
 		   self.container.execute("%s/%s %s" %(fantastic_pluginpath,mfexecute,mftextargument))

	def finished(self,retval):
		fbClass.getInstance().unlock()
		eRCInput.getInstance().unlock()
		eDBoxLCD.getInstance().unlock()
		self.session.nav.playService(eServiceReference(config.tv.lastservice.value))



class FantasticLCD(Screen):
        # use size 0,0 to show text on LCD only
	skin = """
		<screen position="0,0" size="0,0" title="LCD Text" >
			<widget name="text" position="0,0" size="0,0" font="Regular;14" halign="center"/>
		</screen>"""
		
	def __init__(self, session, title = "LCD Text"):
		self.skin = FantasticLCD.skin
		Screen.__init__(self, session)

		self["text"] = Label("")

                # minimal actions to be able to exit after showing LCD Label
		self["actions"] = ActionMap(["WizardActions", "DirectionActions"], 
		{
			"ok": self.cancel,
			"back": self.cancel,
		}, -1)
                # now set passed Text Label for LCD output 		
		self.newtitle = title
		self.onShown.append(self.updateTitle)

	def updateTitle(self):
		self.setTitle(self.newtitle)
			
	def cancel(self):
		self.close()



